package Algebra;

public class Normal {

private double[][] y = new double[6][7];


//Initilalisierung

  public Normal(double[][] y) {
    this.y = y;
  }


  public double gib(int i, int j) {
    return y[i][j];
  }


//  public void initialy(double[6][] y) {
//    this.y = y;
//  }

 

//algemeine Methoden

public int MinIndex(double[] Argument) {
  int Index = 0;
  double Min = Argument[0];
  for (int i=1; i<Argument.length; i++) {
    if (Min > Argument[i] + 0.00001) {
      Min = Argument[i];
      Index = i;
    }
  }
  return Index;
}





//****************
//Methoden fr y[23]
//*******************

//berechnet die mglichen Verbesserungen
public double [] Spur23() {
  double[] s = new double[15];
  s[0] = y[2][4];
  s[1] = y[2][5];
  s[2] = y[2][6];
  s[3] = y[2][3]*y[3][4]-y[2][4];
  s[4] = y[2][3]*y[3][4]*y[4][5]-y[2][3]*y[3][5]-y[2][4]*y[4][5]+y[2][5];
  s[5] = y[1][2]*y[1][6]-y[2][6];
  s[6] = y[2][6]*y[5][6]-y[2][5];
  s[7] = y[1][2]*y[1][5]-y[2][5];
  s[8] = y[1][3];
  s[9] = y[1][4];
  s[10] = y[1][5];
  s[11] = y[1][6];
  s[12] = y[1][2]*y[2][3]-y[1][3];
  s[13] = y[1][2]*y[2][3]*y[3][4]-y[1][2]*y[2][4]-y[1][3]*y[3][4]+y[1][4];
  s[14] = y[1][6]*y[5][6]-y[1][5];
  return s;
}


//berechnet neues Erzeugendensystem entsprechend der mglichen Verbesserung
public void BerechneNeu23(int i) {
  double[][] z = new double[6][7];
    for (byte j=0; j<6; j++)
      for (byte k=0; k<7; k++)
        z[j][k] = y[j][k];
  switch (i) {
  case 0:
    y[1][3] = z[1][4];
    y[1][4] = z[1][4]*z[3][4]-z[1][3];
    y[2][3] = z[2][4];
    y[2][4] = z[2][4]*z[3][4]-z[2][3];
    y[3][5] = z[4][5];
    y[3][6] = z[4][6];
    y[4][5] = z[3][4]*z[4][5]-z[3][5];
    y[4][6] = z[3][4]*z[4][6]-z[3][6];
    break;
  case 1: 
    y[1][3] = z[1][5];
    y[1][4] = z[1][5]*z[3][5]-z[1][3];
    y[1][5] = z[1][5]*z[4][5]-z[1][4];
    y[2][3] = z[2][5];
    y[2][4] = z[2][5]*z[3][5]-z[2][3];
    y[2][5] = z[2][5]*z[4][5]-z[2][4];
    y[3][4] = z[3][5];
    y[3][5] = z[4][5];
    y[3][6] = z[5][6];
    y[4][5] = z[3][4];
    y[4][6] = z[3][5]*z[5][6]-z[3][6];
    y[5][6] = z[4][5]*z[5][6]-z[4][6];
    break;
  case 2: 
    y[1][3] = z[1][6];
    y[1][4] = z[1][6]*z[3][6]-z[1][3];
    y[1][5] = z[1][6]*z[4][6]-z[1][4];
    y[1][6] = z[1][6]*z[5][6]-z[1][5];
    y[2][3] = z[2][6];
    y[2][4] = z[2][6]*z[3][6]-z[2][3];
    y[2][5] = z[2][6]*z[4][6]-z[2][4];
    y[2][6] = z[2][6]*z[5][6]-z[2][5];
    y[3][4] = z[3][6];
    y[3][5] = z[4][6];
    y[3][6] = z[5][6];
    y[4][5] = z[3][4];
    y[4][6] = z[3][5];
    y[5][6] = z[4][5];
    break;
  case 3: 
    y[1][3] = z[1][3]*z[3][4]-z[1][4];
    y[1][4] = z[1][3];
    y[2][3] = z[2][3]*z[3][4]-z[2][4];
    y[2][4] = z[2][3];
    y[3][5] = z[3][4]*z[3][5]-z[4][5];
    y[3][6] = z[3][4]*z[3][6]-z[4][6];
    y[4][5] = z[3][5];
    y[4][6] = z[3][6];
    break;
  case 4: 
    y[1][3] = z[1][3]*z[3][4]*z[4][5]-z[1][3]*z[3][5]-z[1][4]*z[4][5]+z[1][5];
    y[1][4] = z[1][3];
    y[1][5] = z[1][4];
    y[2][3] = z[2][3]*z[3][4]*z[4][5]-z[2][3]*z[3][5]-z[2][4]*z[4][5]+z[2][5];
    y[2][4] = z[2][3];
    y[2][5] = z[2][4];
    y[3][4] = z[3][4]*z[4][5]-z[3][5];
    y[3][5] = z[3][4]*z[3][4]*z[4][5]-z[3][4]*z[3][5]-z[4][5];
    y[3][6] = z[3][6]*z[3][4]*z[4][5]-z[3][6]*z[3][5]-z[4][6]*z[4][5]+z[5][6];
    y[4][5] = z[3][4];
    y[4][6] = z[3][6];
    y[5][6] = z[4][6];
    break;
  case 5: 
    y[1][3] = z[1][2]*z[1][2]*z[1][6]-z[1][2]*z[2][6]-z[1][6];
    y[1][4] = z[1][3];
    y[1][5] = z[1][4];
    y[1][6] = z[1][5];
    y[2][3] = z[1][6]*z[1][2]-z[2][6];
    y[2][4] = z[2][3];
    y[2][5] = z[2][4];
    y[2][6] = z[2][5];
    y[3][4] = z[1][2]*z[2][3]*z[1][6]-z[2][3]*z[2][6]-z[1][3]*z[1][6]+z[3][6];
    y[3][5] = z[1][2]*z[2][4]*z[1][6]-z[2][4]*z[2][6]-z[1][4]*z[1][6]+z[4][6];
    y[3][6] = z[1][2]*z[2][5]*z[1][6]-z[2][5]*z[2][6]-z[1][5]*z[1][6]+z[5][6];
    y[4][5] = z[3][4];
    y[4][6] = z[3][5];
    y[5][6] = z[4][5];
    break;
  case 6: 
    y[1][3] = z[1][6]*z[5][6]-z[1][5];
    y[1][4] = (z[1][6]*z[5][6]-z[1][5])*(z[3][6]*z[5][6]-z[3][5])-z[1][3];
    y[1][5] = (z[1][6]*z[5][6]-z[1][5])*(z[4][6]*z[5][6]-z[4][5])-z[1][4];
    y[1][6] = z[5][6]*z[5][6]*z[1][6]-z[5][6]*z[1][5]-z[1][6];
    y[2][3] = z[2][6]*z[5][6]-z[2][5];
    y[2][4] = (z[2][6]*z[5][6]-z[2][5])*(z[3][6]*z[5][6]-z[3][5])-z[2][3];
    y[2][5] = (z[2][6]*z[5][6]-z[2][5])*(z[4][6]*z[5][6]-z[4][5])-z[2][4];
    y[2][6] = z[5][6]*z[5][6]*z[2][6]-z[5][6]*z[2][5]-z[2][6];
    y[3][4] = z[3][6]*z[5][6]-z[3][5];
    y[3][5] = z[4][6]*z[5][6]-z[4][5];
    y[3][6] = z[5][6];
    y[4][5] = z[3][4];
    y[4][6] = z[3][6];
    y[5][6] = z[4][6];
    break;
  case 7: 
    y[1][3] = z[1][2]*z[1][2]*z[1][5]-z[1][2]*z[2][5]-z[1][5];
    y[1][4] = z[1][2]*z[1][2]*z[1][6]-z[1][2]*z[2][6]-z[1][6];
    y[1][5] = z[1][3];
    y[1][6] = z[1][4];
    y[2][3] = z[1][5]*z[1][2]-z[2][5];
    y[2][4] = z[1][6]*z[1][2]-z[2][6];
    y[2][5] = z[2][3];
    y[2][6] = z[2][4];
    y[3][4] = z[5][6];
    y[3][5] = z[1][2]*z[2][3]*z[1][5]-z[2][3]*z[2][5]-z[1][3]*z[1][5]+z[3][5];
    y[3][6] = z[1][2]*z[2][4]*z[1][5]-z[2][4]*z[2][5]-z[1][4]*z[1][5]+z[4][5];
    y[4][5] = z[1][2]*z[2][3]*z[1][6]-z[2][3]*z[2][6]-z[1][3]*z[1][6]+z[3][6];
    y[4][6] = z[1][2]*z[2][4]*z[1][6]-z[2][4]*z[2][6]-z[1][4]*z[1][6]+z[4][6];
    y[5][6] = z[3][4];
    break;
  case 8: 
    y[1][3] = z[2][3];
    y[1][4] = z[2][3]*z[3][6]-z[2][6];
    y[1][5] = z[2][3]*z[3][5]-z[2][5];
    y[1][6] = z[2][3]*z[3][4]-z[2][4];
    y[2][3] = z[1][3];
    y[2][4] = z[1][3]*z[3][6]-z[1][6];
    y[2][5] = z[1][3]*z[3][5]-z[1][5];
    y[2][6] = z[1][3]*z[3][4]-z[1][4];
    y[3][4] = z[3][6];
    y[3][6] = z[3][4];
    y[4][5] = z[5][6];
    y[5][6] = z[4][5];
    break;
  case 9: 
    y[1][3] = z[2][4];
    y[1][4] = z[2][4]*z[4][6]-z[2][6];
    y[1][5] = z[2][4]*z[4][5]-z[2][5];
    y[1][6] = z[2][3];
    y[2][3] = z[1][4];
    y[2][4] = z[1][4]*z[4][6]-z[1][6];
    y[2][5] = z[1][4]*z[4][5]-z[1][5];
    y[2][6] = z[1][3];
    y[3][4] = z[4][6];
    y[3][5] = z[4][5];
    y[3][6] = z[3][4];
    y[4][5] = z[5][6];
    y[4][6] = z[3][4]*z[4][6]-z[3][6];
    y[5][6] = z[3][4]*z[4][5]-z[3][5];
    break;
  case 10: 
    y[1][3] = z[2][5];
    y[1][4] = z[2][5]*z[5][6]-z[2][6];
    y[1][5] = z[2][4];
    y[1][6] = z[2][3];
    y[2][3] = z[1][5];
    y[2][4] = z[1][5]*z[5][6]-z[1][6];
    y[2][5] = z[1][4];
    y[2][6] = z[1][3];
    y[3][4] = z[5][6];
    y[3][5] = z[4][5];
    y[3][6] = z[3][5];
    y[4][5] = z[4][5]*z[5][6]-z[4][6];
    y[4][6] = z[3][5]*z[5][6]-z[3][6];
    y[5][6] = z[3][4];
    break;
  case 11: 
    y[1][3] = z[2][6];
    y[1][4] = z[2][5];
    y[1][5] = z[2][4];
    y[1][6] = z[2][3];
    y[2][3] = z[1][6];
    y[2][4] = z[1][5];
    y[2][5] = z[1][4];
    y[2][6] = z[1][3];
    y[3][4] = z[5][6];
    y[3][5] = z[4][6];
    y[3][6] = z[3][6];
    y[4][5] = z[4][5];
    y[4][6] = z[3][5];
    y[5][6] = z[3][4];
    break;
  case 12: 
    y[1][3] = z[1][2]*z[1][2]*z[2][3]-z[1][2]*z[1][3]-z[2][3];
    y[1][4] = z[2][6];
    y[1][5] = z[2][5];
    y[1][6] = z[2][4];
    y[2][3] = z[1][2]*z[2][3]-z[1][3];
    y[2][4] = z[1][6];
    y[2][5] = z[1][5];
    y[2][6] = z[1][4];
    y[3][4] = z[1][6]*z[1][2]*z[2][3]-z[1][6]*z[1][3]-z[2][3]*z[2][6]+z[3][6];
    y[3][5] = z[1][5]*z[1][2]*z[2][3]-z[1][5]*z[1][3]-z[2][3]*z[2][5]+z[3][5];
    y[3][6] = z[1][4]*z[1][2]*z[2][3]-z[1][4]*z[1][3]-z[2][3]*z[2][4]+z[3][4];
    y[4][5] = z[5][6];
    y[5][6] = z[4][5];
    break;
  case 13: 
    y[1][3] = z[2][6]*z[4][5]*z[5][6]-z[2][6]*z[4][6]-z[2][5]*z[4][5]+z[2][4];
    y[1][4] = z[2][6];
    y[1][5] = z[2][5];
    y[1][6] = z[2][3];
    y[2][3] = z[1][2]*z[2][3]*z[3][4]-z[1][2]*z[2][4]-z[1][3]*z[3][4]+z[1][4];
    y[2][4] = z[1][6];
    y[2][5] = z[1][5];
    y[2][6] = z[1][3];
    y[3][4] = z[4][5]*z[5][6]-z[4][6];
    y[3][5] = z[5][6]*z[5][6]*z[4][5]-z[5][6]*z[4][6]-z[4][5];
    y[3][6] = z[3][6]*z[4][5]*z[5][6]-z[3][6]*z[4][6]-z[3][5]*z[4][5]+z[3][4];
    y[4][5] = z[5][6];
    y[4][6] = z[3][6];
    y[5][6] = z[3][5];
    break;
  case 14: 
    y[1][3] = z[2][6]*z[5][6]-z[2][5];
    y[1][4] = z[2][6];
    y[1][5] = z[2][4];
    y[1][6] = z[2][3];
    y[2][3] = z[1][6]*z[5][6]-z[1][5];
    y[2][4] = z[1][6];
    y[2][5] = z[1][4];
    y[2][6] = z[1][3];
    y[3][4] = z[5][6];
    y[3][5] = z[4][6]*z[5][6]-z[4][5];
    y[3][6] = z[3][6]*z[5][6]-z[3][5];
    y[4][5] = z[4][6];
    y[4][6] = z[3][6];
    y[5][6] = z[3][4];
    break;
  default: System.out.println("Falscher Index "+i+" in BerechneNeu23"); break;
  }
}


//zyklisch23 entspricht (x[3],x[2],x[1],x[6],x[5],x[4])
public void zyklisch23() {
  double[][] z = new double[6][7];
    for (byte j=0; j<6; j++)
      for (byte k=0; k<7; k++)
        z[j][k] = y[j][k];
    y[1][2] = z[2][3];
    y[1][3] = z[1][3];
    y[1][4] = z[3][6];
    y[1][5] = z[3][5];
    y[1][6] = z[3][4];
    y[2][3] = z[1][2];
    y[2][4] = z[2][6];
    y[2][5] = z[2][5];
    y[2][6] = z[2][4];
    y[3][4] = z[1][6];
    y[3][5] = z[1][5];
    y[3][6] = z[1][4];
    y[4][5] = z[5][6];
    y[4][6] = z[4][6];
    y[5][6] = z[4][5];
}

//zyklisch56 entspricht (x[6],x[5],x[4],x[3],x[2],x[1])
public void zyklisch56() {
  double[][] z = new double[6][7];
    for (byte j=0; j<6; j++)
      for (byte k=0; k<7; k++)
        z[j][k] = y[j][k];
    y[1][2] = z[5][6];
    y[1][3] = z[4][6];
    y[1][4] = z[3][6];
    y[1][5] = z[2][6];
    y[1][6] = z[1][6];
    y[2][3] = z[4][5];
    y[2][4] = z[3][5];
    y[2][5] = z[2][5];
    y[2][6] = z[1][5];
    y[3][4] = z[3][4];
    y[3][5] = z[2][4];
    y[3][6] = z[1][4];
    y[4][5] = z[2][3];
    y[4][6] = z[1][3];
    y[5][6] = z[1][2];
}


//macht y[23] (und y[12]) optimal
public void Methode23() {
  double[] Spur = Spur23();
  int Index = MinIndex(Spur);
  while (Spur[Index]<y[2][3]-0.0001) {
    BerechneNeu23(Index);
    if (y[2][3]<y[1][2]-0.0001)
      zyklisch23();
    if (y[5][6]<y[1][2]-0.0001)
      zyklisch56();
    Spur = Spur23();
    Index = MinIndex(Spur);
  }
}


//****************
//Methoden fr y[34]
//*******************


//berechnet die mglichen Verbesserungen
public double [] Spur34() {
  double[] s = new double[6];
  s[0] = y[3][5];
  s[1] = y[3][6];
  s[2] = y[3][4]*y[4][5]-y[3][5];
  s[3] = y[3][4]*y[4][5]*y[5][6]-y[3][4]*y[4][6]-y[3][5]*y[5][6]+y[3][6];
  s[4] = y[3][6]*y[5][6]*y[4][5]-y[3][5]*y[4][5]-y[3][6]*y[4][6]+y[3][4];
  s[5] = y[4][6]*(y[3][4]*y[4][5]*y[5][6]-y[3][5]*y[5][6]-y[3][4]*y[4][6]+y[3][6])-y[3][4]*y[4][5]*y[4][5]+y[3][5]*y[4][5]+y[3][4];
  return s;
}



//berechnet neues Erzeugendensystem entsprechend der mglichen Verbesserung
public void BerechneNeu34(int i) {
  double[][] z = new double[6][7];
    for (byte j=0; j<6; j++)
      for (byte k=0; k<7; k++)
        z[j][k] = y[j][k];
  switch (i) {
  case 0: 
    y[1][4] = z[1][5];
    y[1][5] = z[1][5]*z[4][5]-z[1][4];
    y[2][4] = z[2][5];
    y[2][5] = z[2][5]*z[4][5]-z[2][4];
    y[3][4] = z[3][5];
    y[3][5] = z[3][5]*z[4][5]-z[3][4];
    y[4][6] = z[5][6];
    y[5][6] = z[4][5]*z[5][6]-z[4][6];
    break;
  case 1: 
    y[1][4] = z[1][6];
    y[1][5] = z[1][6]*z[4][6]-z[1][4];
    y[1][6] = z[1][6]*z[5][6]-z[1][5];
    y[2][4] = z[2][6];
    y[2][5] = z[2][6]*z[4][6]-z[2][4];
    y[2][6] = z[2][6]*z[5][6]-z[2][5];
    y[3][4] = z[3][6];
    y[3][5] = z[3][6]*z[4][6]-z[3][4];
    y[3][6] = z[3][6]*z[5][6]-z[3][5];
    y[4][5] = z[4][6];
    y[4][6] = z[5][6];
    y[5][6] = z[4][5];
    break;
  case 2: 
    y[1][4] = z[1][4]*z[4][5]-z[1][5];
    y[1][5] = z[1][4];
    y[2][4] = z[2][4]*z[4][5]-z[2][5];
    y[2][5] = z[2][4];
    y[3][4] = z[3][4]*z[4][5]-z[3][5];
    y[3][5] = z[3][4];
    y[4][6] = z[4][5]*z[4][6]-z[5][6];
    y[5][6] = z[4][6];
    break;
  case 3: 
    y[1][4] = z[1][4]*z[4][5]*z[5][6]-z[1][4]*z[4][6]-z[1][5]*z[5][6]+z[1][6];
    y[1][5] = z[1][4];
    y[1][6] = z[1][5];
    y[2][4] = z[2][4]*z[4][5]*z[5][6]-z[2][4]*z[4][6]-z[2][5]*z[5][6]+z[2][6];
    y[2][5] = z[2][4];
    y[2][6] = z[2][5];
    y[3][4] = z[3][4]*z[4][5]*z[5][6]-z[3][4]*z[4][6]-z[3][5]*z[5][6]+z[3][6];
    y[3][5] = z[3][4];
    y[3][6] = z[3][5];
    y[4][5] = z[4][5]*z[5][6]-z[4][6];
    y[4][6] = z[4][5]*z[4][5]*z[5][6]-z[4][5]*z[4][6]-z[5][6];
    y[5][6] = z[4][5];
    break;
  case 4: 
    y[1][4] = z[1][6]*z[5][6]*z[4][5]-z[1][5]*z[4][5]-z[1][6]*z[4][6]+z[1][4];
    y[1][5] = z[4][5]*(z[4][5]*z[1][6]*z[5][6]-z[4][5]*z[1][5]-z[1][6]*z[4][6]+z[1][4])-z[1][6]*z[5][6]+z[1][5];
    y[1][6] = z[1][6]*(z[4][6]*z[4][5]*z[5][6]-z[4][6]*z[4][6]-z[5][6]*z[5][6]+2)-z[1][5]*z[4][5]*z[4][6]+z[1][5]*z[5][6]+z[1][4]*z[4][6]-z[1][6];
    y[2][4] = z[2][6]*z[5][6]*z[4][5]-z[2][5]*z[4][5]-z[2][6]*z[4][6]+z[2][4];
    y[2][5] = z[4][5]*(z[4][5]*z[2][6]*z[5][6]-z[4][5]*z[2][5]-z[2][6]*z[4][6]+z[2][4])-z[2][6]*z[5][6]+z[2][5];
    y[2][6] = z[2][6]*(z[4][6]*z[4][5]*z[5][6]-z[4][6]*z[4][6]-z[5][6]*z[5][6]+2)-z[2][5]*z[4][5]*z[4][6]+z[2][5]*z[5][6]+z[2][4]*z[4][6]-z[2][6];
    y[3][4] = z[3][6]*z[5][6]*z[4][5]-z[3][5]*z[4][5]-z[3][6]*z[4][6]+z[3][4];
    y[3][5] = z[4][5]*(z[4][5]*z[3][6]*z[5][6]-z[4][5]*z[3][5]-z[3][6]*z[4][6]+z[3][4])-z[3][6]*z[5][6]+z[3][5];
    y[3][6] = z[3][6]*(z[4][6]*z[4][5]*z[5][6]-z[4][6]*z[4][6]-z[5][6]*z[5][6]+2)-z[3][5]*z[4][5]*z[4][6]+z[3][5]*z[5][6]+z[3][4]*z[4][6]-z[3][6];
    break;
  case 5: 
    y[1][4] = z[4][6]*(z[1][4]*z[4][5]*z[5][6]-z[1][5]*z[5][6]-z[1][4]*z[4][6]+z[1][6])-z[1][4]*z[4][5]*z[4][5]+z[1][5]*z[4][5]+z[1][4];
    y[1][5] = z[1][4]*z[4][5]-z[1][5];
    y[1][6] = z[1][4]*z[4][6]-z[1][6];
    y[2][4] = z[4][6]*(z[2][4]*z[4][5]*z[5][6]-z[2][5]*z[5][6]-z[2][4]*z[4][6]+z[2][6])-z[2][4]*z[4][5]*z[4][5]+z[2][5]*z[4][5]+z[2][4];
    y[2][5] = z[2][4]*z[4][5]-z[2][5];
    y[2][6] = z[2][4]*z[4][6]-z[2][6];
    y[3][4] = z[4][6]*(z[3][4]*z[4][5]*z[5][6]-z[3][5]*z[5][6]-z[3][4]*z[4][6]+z[3][6])-z[3][4]*z[4][5]*z[4][5]+z[3][5]*z[4][5]+z[3][4];
    y[3][5] = z[3][4]*z[4][5]-z[3][5];
    y[3][6] = z[3][4]*z[4][6]-z[3][6];
    y[4][5] = z[4][6]*z[5][6]-z[4][5];
    y[4][6] = z[5][6]*z[5][6]*z[4][6]-z[4][5]*z[5][6]-z[4][6];
    break;
  default: System.out.println("Falscher Index "+i+" in BerechneNeu34"); break;
  }
}

//zyklisch34 entspricht (x[4],x[3],x[2],x[1],x[6],x[5])
public void zyklisch34() {
  double[][] z = new double[6][7];
    for (byte j=0; j<6; j++)
      for (byte k=0; k<7; k++)
        z[j][k] = y[j][k];
    y[1][2] = z[3][4];
    y[1][3] = z[2][4];
    y[1][4] = z[1][4];
    y[1][5] = z[4][6];
    y[1][6] = z[4][5];
    y[2][3] = z[2][3];
    y[2][4] = z[1][3];
    y[2][5] = z[3][6];
    y[2][6] = z[3][5];
    y[3][4] = z[1][2];
    y[3][5] = z[2][6];
    y[3][6] = z[2][5];
    y[4][5] = z[1][6];
    y[4][6] = z[1][5];
    y[5][6] = z[5][6];
}


//macht y[34] (und y[12], y[23]) optimal
public void Methode34() {
  double[] Spur = Spur34();
  int Index = MinIndex(Spur);
  while (Spur[Index]<y[3][4]-0.0001) {
    BerechneNeu34(Index);
    if (y[3][4]<y[1][2]-0.0001)
      zyklisch34();
    if (y[5][6]<y[1][2]-0.0001)
      zyklisch56();
    Methode23();
    Spur = Spur34();
    Index = MinIndex(Spur);
  }
}


//****************
//Methoden fr y[45]
//*******************


//berechnet die mglichen Verbesserungen
public double [] Spur45() {
  double[] s = new double[2];
  s[0] = y[4][6];
  s[1] = y[4][5]*y[5][6]-y[4][6];
  return s;
}



//berechnet neues Erzeugendensystem entsprechend der mglichen Verbesserung
public void BerechneNeu45(int i) {
  double[][] z = new double[6][7];
    for (byte j=0; j<6; j++)
      for (byte k=0; k<7; k++)
        z[j][k] = y[j][k];
  switch (i) {
  case 0: 
    y[1][5] = z[1][6];
    y[1][6] = z[1][6]*z[5][6]-z[1][5];
    y[2][5] = z[2][6];
    y[2][6] = z[2][6]*z[5][6]-z[2][5];
    y[3][5] = z[3][6];
    y[3][6] = z[3][6]*z[5][6]-z[3][5];
    y[4][5] = z[4][6];
    y[4][6] = z[4][6]*z[5][6]-z[4][5];
    break;
  case 1: 
    y[1][5] = z[1][5]*z[5][6]-z[1][6];
    y[1][6] = z[1][5];
    y[2][5] = z[2][5]*z[5][6]-z[2][6];
    y[2][6] = z[2][5];
    y[3][5] = z[3][5]*z[5][6]-z[3][6];
    y[3][6] = z[3][5];
    y[4][5] = z[4][5]*z[5][6]-z[4][6];
    y[4][6] = z[4][5];
    break;
  default: System.out.println("Falscher Index "+i+" in BerechneNeu45"); break;
  }
}

//zyklisch45 entspricht (x[5],x[4],x[3],x[2],x[1],x[6])
public void zyklisch45() {
  double[][] z = new double[6][7];
    for (byte j=0; j<6; j++)
      for (byte k=0; k<7; k++)
        z[j][k] = y[j][k];
    y[1][2] = z[4][5];
    y[1][3] = z[3][5];
    y[1][4] = z[2][5];
    y[1][5] = z[1][5];
    y[1][6] = z[5][6];
    y[2][3] = z[3][4];
    y[2][4] = z[2][4];
    y[2][5] = z[1][4];
    y[2][6] = z[4][6];
    y[3][4] = z[2][3];
    y[3][5] = z[1][3];
    y[3][6] = z[3][6];
    y[4][5] = z[1][2];
    y[4][6] = z[2][6];
    y[5][6] = z[1][6];
}

//****************
//Einschub
//**************
//Methoden fr y[12]
//*****************

//zyklisch16 entspricht (x[6],x[1],x[2],x[3],x[4],x[5])
public void zyklisch16() {
  double[][] z = new double[6][7];
    for (byte j=0; j<6; j++)
      for (byte k=0; k<7; k++)
        z[j][k] = y[j][k];
    y[1][2] = z[1][6];
    y[1][3] = z[2][6];
    y[1][4] = z[3][6];
    y[1][5] = z[4][6];
    y[1][6] = z[5][6];
    y[2][3] = z[1][2];
    y[2][4] = z[1][3];
    y[2][5] = z[1][4];
    y[2][6] = z[1][5];
    y[3][4] = z[2][3];
    y[3][5] = z[2][4];
    y[3][6] = z[2][5];
    y[4][5] = z[3][4];
    y[4][6] = z[3][5];
    y[5][6] = z[4][5];
}



public void Min12() {
  double[][] z = new double[6][7];
    for (byte j=0; j<6; j++)
      for (byte k=0; k<7; k++)
        z[j][k] = y[j][k];
  double[] Nebenspuren = new double[6];
  Nebenspuren[0] = y[1][2];
  Nebenspuren[1] = y[2][3];
  Nebenspuren[2] = y[3][4];
  Nebenspuren[3] = y[4][5];
  Nebenspuren[4] = y[5][6];
  Nebenspuren[5] = y[1][6];
  switch (MinIndex(Nebenspuren)) {
  case 1:
    zyklisch23(); break;
  case 2:
    zyklisch34(); break;
  case 3:
    zyklisch45(); break;
  case 4:
    zyklisch56(); break;
  case 5:
    zyklisch16(); break;
  default: System.out.println("y12 war minimal."); break;
  }
}

//macht y[45] (und y[12], y[23], y[34]) optimal und gibt Normalform aus
public void Methode45() {
  Min12();
  Methode23();
  Methode34();
  double[] Spur = Spur45();
  int Index = MinIndex(Spur);
  while (Spur[Index]<y[4][5]-0.0001) {
    BerechneNeu45(Index);
    if (y[4][5]<y[1][2]-0.0001)
      zyklisch45();
    if (y[5][6]<y[1][2]-0.0001)
      zyklisch56();
    Methode23();
    Methode34();
    Spur = Spur45();
    Index = MinIndex(Spur);
  }
  System.out.println("y[12] = "+y[1][2]);
  System.out.println("y[13] = "+y[1][3]);
  System.out.println("y[14] = "+y[1][4]);
  System.out.println("y[15] = "+y[1][5]);
  System.out.println("y[16] = "+y[1][6]);
  System.out.println("y[23] = "+y[2][3]);
    System.out.println("< "+y[2][4]+", "+y[2][5]+", "+y[2][6]+", "+(y[2][3]*y[3][4]-y[2][4])+", "+(y[2][3]*y[3][4]*y[4][5]-y[2][3]*y[3][5]-y[2][4]*y[4][5]+y[2][5])+", "+(y[1][2]*y[1][6]-y[2][6])+", "+(y[2][6]*y[5][6]-y[2][5])+", "+(y[1][2]*y[1][5]-y[2][5])+", "+y[1][3]+", "+y[1][4]+", "+y[1][5]+", "+y[1][6]+", "+(y[1][2]*y[2][3]-y[1][3])+", "+(y[1][2]*y[2][3]*y[3][4]-y[1][2]*y[2][4]-y[1][3]*y[3][4]+y[1][4])+", "+(y[1][6]*y[5][6]-y[1][5]));
  System.out.println("y[24] = "+y[2][4]);
  System.out.println("y[25] = "+y[2][5]);
  System.out.println("y[26] = "+y[2][6]);
  System.out.println("y[34] = "+y[3][4]);
    System.out.println("< "+y[3][5]+", "+y[3][6]+", "+(y[3][4]*y[4][5]-y[3][5])+", "+(y[3][4]*y[4][5]*y[5][6]-y[3][4]*y[4][6]-y[3][5]*y[5][6]+y[3][6])+", "+(y[3][6]*y[5][6]*y[4][5]-y[3][5]*y[4][5]-y[3][6]*y[4][6]+y[3][4])+", "+(y[4][6]*(y[3][4]*y[4][5]*y[5][6]-y[3][5]*y[5][6]-y[3][4]*y[4][6]+y[3][6])-y[3][4]*y[4][5]*y[4][5]+y[3][5]*y[4][5]+y[3][4]));
  System.out.println("y[35] = "+y[3][5]);
  System.out.println("y[36] = "+y[3][6]);
  System.out.println("y[45] = "+y[4][5]);
    System.out.println("< "+y[4][6]+", "+(y[4][5]*y[5][6]-y[4][6]));
  System.out.println("y[46] = "+y[4][6]);
  System.out.println("y[56] = "+y[5][6]);
  System.out.println(" ");
  System.out.println("als Quadrate:");
  System.out.print("("+Math.floor(y[1][2]*y[1][2]+0.0001)+",");
  System.out.print(Math.floor(y[1][3]*y[1][3]+0.0001)+",");
  System.out.print(Math.floor(y[1][4]*y[1][4]+0.0001)+",");
  System.out.print(Math.floor(y[1][5]*y[1][5]+0.0001)+",");
  System.out.print(Math.floor(y[1][6]*y[1][6]+0.0001)+",");
  System.out.print(Math.floor(y[2][3]*y[2][3]+0.0001)+",");
  System.out.print(Math.floor(y[2][4]*y[2][4]+0.0001)+",");
  System.out.print(Math.floor(y[2][5]*y[2][5]+0.0001)+",");
  System.out.print(Math.floor(y[2][6]*y[2][6]+0.0001)+",");
  System.out.print(Math.floor(y[3][4]*y[3][4]+0.0001)+",");
  System.out.print(Math.floor(y[3][5]*y[3][5]+0.0001)+",");
  System.out.print(Math.floor(y[3][6]*y[3][6]+0.0001)+",");
  System.out.print(Math.floor(y[4][5]*y[4][5]+0.0001)+",");
  System.out.print(Math.floor(y[4][6]*y[4][6]+0.0001)+",");
  System.out.println(Math.floor(y[5][6]*y[5][6]+0.0001)+")");

}




}
